---
title: Styling Columns
slug: Web/CSS/CSS_Columns/Styling_Columns
tags:
  - CSS
  - CSS Multi-column Layout
  - Guide
  - Layout
---
<div>{{CSSRef}}</div>

<p class="summary">As column boxes created inside multicol containers are anonymous boxes, there is little we can do to style them. However, we do have a few things that we can do. This guide explains how to change the gap and style rules between columns.</p>

<h2 id="Can_I_Style_the_Column_Boxes">Can I Style the Column Boxes?</h2>

<p>Sadly, not at present. The anonymous boxes that make up your columns can’t be targeted in any way, meaning it isn’t possible to change a box's background color or have one column larger than the others. Perhaps in future versions of the specification it might be. For now, however, we are able to change the spacing and add lines between columns.</p>

<h2 id="The_column-gap_property">The <code>column-gap</code> property</h2>

<p>The gap between our columns is controlled by the <code>column-gap</code> property. This property was originally defined in the Multi-column Layout specification. However, it is now defined in <a href="/en-US/docs/Web/CSS/CSS_Box_Alignment">Box Alignment</a> in order to unify gaps between boxes in other specifications such as <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Box_Alignment_in_CSS_Grid_Layout">CSS Grid Layout</a>.</p>

<p>The initial value of <code>column-gap</code> in multicol is <code>1em</code>. This means your columns will not run into each other. In other layout methods the initial value for <code>column-gap</code> is 0. If you use the keyword value “normal” the gap will be set to 1em.</p>

<p>You can change the gap by using any length unit as the value of <code>column-gap</code>. In the example below, the <code>column-gap</code> is set to 40px.</p>

<p>{{EmbedGHLiveSample("css-examples/multicol/styling/column-gap.html", '100%', 750)}}</p>

<p>The allowed value for <code>column-gap</code> is a <code>&lt;length-percentage&gt;</code>, this means percentages are allowed. Percentage values for <code>column-gap</code> are calculated as a percentage of the width of the multicol container.</p>

<h2 id="Column_rules">Column rules</h2>

<p>The specification defines <code>column-rule-width</code>, <code>column-rule-style</code> and <code>column-rule-color</code>, providing a shorthand <code>column-rule</code>. These properties work in exactly the same way as the <code>border</code> properties: any valid <code>border-style</code> can be used as a <code>column-rule-style</code>.</p>

<p>These properties are applied to the element which is the multicol container and therefore all columns will have the same rule. Rules are only drawn between columns and not on the outer edges. Rules should also only be drawn between columns which have content.</p>

<p>In this next example I have created a 5px dotted rule with a color of rebeccapurple, using the longhand values.</p>

<p>{{EmbedGHLiveSample("css-examples/multicol/styling/column-rule.html", '100%', 550)}}</p>

<p>Note that the rule itself does not take up any space: a wide rule will not push the columns apart to make space for the rule. Instead, the rule overlays the gap.</p>

<p>In this next example we have a very wide rule of 40px and a 10px gap. The rule displays under the content of the columns. In order to make space on both sides of the rule, the gap would need to be increased to be larger than 40px.</p>

<p>{{EmbedGHLiveSample("css-examples/multicol/styling/column-rule-wide.html", '100%', 550)}}</p>

<h2 id="Summary">Summary</h2>

<p>This details all the current ways in which column boxes can be styled. In the next guide we will take a look at making elements inside a container <a href="/en-US/docs/Web/CSS/CSS_Columns/Spanning_Columns">span across all columns</a>.</p>
